﻿using Infragistics.Documents.RichText;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RichTextSelectedTextProperties
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            RichTextDocument rich = new RichTextDocument();

            RunNode r1 = new RunNode();
            r1.Settings = new CharacterSettings
            {
                FontSize = new Extent(15, ExtentUnitType.Points),
                FontSettings = new FontSettings
                {
                    Ascii = "Arial",
                }
            };
            r1.SetText("Arial 15 ");

            RunNode r2 = new RunNode();
            r2.Settings = new CharacterSettings
            {
                FontSize = new Extent(9, ExtentUnitType.Points),
                FontSettings = new FontSettings
                {
                    Ascii = "Verdana",
                }
            };
            r2.SetText("Verdana 9");

            RunNode r3 = new RunNode();
            r3.Settings = new CharacterSettings
            {
                FontSize = new Extent(15, ExtentUnitType.Points),
                FontSettings = new FontSettings
                {
                    Ascii = "Arial",
                }
            };
            r3.SetText("Arial 15 ");

            ParagraphNode p = new ParagraphNode();
            p.ChildNodes.Add(r1);
            p.ChildNodes.Add(r2);
            p.ChildNodes.Add(r3);

            rich.RootNode.Body.ChildNodes.Add(p);

            RunNode r11 = new RunNode();
            r11.Settings = new CharacterSettings
            {
                FontSize = new Extent(15, ExtentUnitType.Points),
                FontSettings = new FontSettings
                {
                    Ascii = "Arial",
                }
            };
            r11.SetText("Arial 15 ");

            RunNode r21 = new RunNode();
            r21.Settings = new CharacterSettings
            {
                FontSize = new Extent(9, ExtentUnitType.Points),
                FontSettings = new FontSettings
                {
                    Ascii = "Verdana",
                }
            };
            r21.SetText("Verdana 9");

            RunNode r31 = new RunNode();
            r31.Settings = new CharacterSettings
            {
                FontSize = new Extent(15, ExtentUnitType.Points),
                FontSettings = new FontSettings
                {
                    Ascii = "Arial",
                }
            };
            r31.SetText("Arial 15 ");

            ParagraphNode p1 = new ParagraphNode();
            p1.ChildNodes.Add(r11);
            p1.ChildNodes.Add(r21);
            p1.ChildNodes.Add(r31);

            rich.RootNode.Body.ChildNodes.Add(p1);

            xamRichText.Document = rich;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var settings = xamRichText.Document.GetCommonCharacterSettings(xamRichText.Selection.DocumentSpan);


            var paragraphs = xamRichText.Document.GetParagraphs(xamRichText.Selection.DocumentSpan);

            List<RunNode> allRunNodesInSelection = new List<RunNode>();
            GetFlatRunNodeList(paragraphs, allRunNodesInSelection);


            List<RunNode> selectedRunNodes =
                allRunNodesInSelection.Where(rn => IsNodeInSelection(rn, xamRichText.Selection)).ToList();



        }

        public bool IsNodeInSelection(RunNode node, Selection selection)
        {
            DocumentSpan nodeSpan = node.GetDocumentSpan();
            DocumentSpan selectionSpan = selection.DocumentSpan;

            if((nodeSpan.Start >= selectionSpan.Start && nodeSpan.Start <= selectionSpan.End)
                || (nodeSpan.Start < selectionSpan.Start && nodeSpan.End > selectionSpan.Start))
                return true;

            return false;
        }

        public void GetFlatRunNodeList(IEnumerable<NodeBase> nodes, List<RunNode> result)
        {
            foreach (var p in nodes)
            { 
                foreach (var ch in p.ChildNodes)
                {
                    if(ch is RunNode)
                        result.Add(ch as RunNode);

                    if (ch.HasChildNodes)
                        GetFlatRunNodeList(ch.ChildNodes, result);                                       
                }
            }
        }
    }
}
